-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

return {
  -- Any dataplane older than 2.8.1.1
  ["2.8.1.1"] = {
    -- Enterprise plugins
    mtls_auth = {
      "http_proxy_host",
      "http_proxy_port",
      "https_proxy_host",
      "https_proxy_port",
    },
  },

  -- Any dataplane older than 2.8.1.3
  ["2.8.1.3"] = {
    -- OSS plugins
    acme = {
      "allow_any_domain",
    },
    aws_lambda = {
      "aws_assume_role_arn",
      "aws_role_session_name",
    },
  },

  -- Any dataplane older than 3.0.0
  ["3.0"] = {
    -- OSS
    zipkin = {
      "http_span_name",
      "connect_timeout",
      "send_timeout",
      "read_timeout",
    },
    pre_function = {
      "ws_handshake",
      "ws_client_frame",
      "ws_upstream_frame",
      "ws_close",
    },
    post_function = {
      "ws_handshake",
      "ws_client_frame",
      "ws_upstream_frame",
      "ws_close",
    },
    prometheus = {
      "status_code_metrics",
      "latency_metrics",
      "bandwidth_metrics",
      "upstream_health_metrics",
    },
    opentelemetry = {
      "connect_timeout",
      "send_timeout",
      "read_timeout",
    },
    statsd = {
      "allow_status_codes",
      "udp_packet_size",
      "use_tcp",
      "hostname_in_prefix",
      "consumer_identifier_default",
      "service_identifier_default",
      "workspace_identifier_default",
    },

    -- Enterprise plugins
    opa = {
      "include_body_in_opa_input",
      "include_parsed_json_body_in_opa_input",
      "ssl_verify",
    },
    degraphql = {
      "graphql_server_path",
    },
    statsd_advanced = {
      "consumer_identifier_default",
      "service_identifier_default",
      "workspace_identifier_default",
    },
    ldap_auth_advanced = {
      "groups_required",
    },
  },

  -- Any dataplane older than 3.1.0
  ["3.1.0"] = {
    -- OSS
    acme = {
      "enable_ipv4_common_name",
      "storage_config.redis.ssl",
      "storage_config.redis.ssl_verify",
      "storage_config.redis.ssl_server_name",
    },
    rate_limiting = {
      "error_code",
      "error_message",
    },
    response_ratelimiting = {
      "redis_ssl",
      "redis_ssl_verify",
      "redis_server_name",
    },
    datadog = {
      "retry_count",
      "queue_size",
      "flush_timeout",
    },
    statsd = {
      "retry_count",
      "queue_size",
      "flush_timeout",
    },
    session = {
      "cookie_persistent",
    },
    zipkin = {
      "http_response_header_for_traceid",
    },

    -- Enterprise plugins
    mocking = {
      "included_status_codes",
      "random_status_code",
    },
    opa = {
      "include_uri_captures_in_opa_input",
    },
    forward_proxy = {
      "x_headers",
    },
    rate_limiting_advanced = {
      "disable_penalty",
      "error_code",
      "error_message",
    },
    mtls_auth = {
      "allow_partial_chain",
      "send_ca_dn",
    },
    request_transformer_advanced = {
      "dots_in_keys",
      "add.json_types",
      "append.json_types",
      "replace.json_types",
    },
    route_transformer_advanced = {
      "escape_path",
    },
  },
}
