/*
  This software is copyright Kong Inc. and its licensors.
  Use of the software is subject to the agreement between your organization
  and Kong Inc. If there is no such agreement, use is governed by and
  subject to the terms of the Kong Master Software License Agreement found
  at https://konghq.com/enterprisesoftwarelicense/.
*/


import{_ as x,K as S,G as D,V as O,A as V,c as p,f as m,J as Q,w as o,h as g,b as d,q as _,r as u,o as c,a as F,d as h,t as f,O as k,P as v}from"./index.9c766b32.js";import{E as B}from"./EntityMixin.41a00d96.js";import{P as C}from"./PageHeader.f57bc0c5.js";import{E as H}from"./EntityList.3eb9ead7.js";import{S as K}from"./SupportText.46d57bf3.js";import{L as N}from"./ListPageMixin.043645e4.js";import{R as q}from"./RedirectMixin.43c88d07.js";import{b as M}from"./buildRoute.43b36aba.js";import{_ as j}from"./PluginIcon.vue_vue_type_script_setup_true_lang.2c07345e.js";import"./EntityButton.b0e2795e.js";import"./EntityFilter.a45e67f0.js";import"./preferences.669a52f4.js";import"./EntityListEmptyState.595e7f8f.js";import"./icon-empty-table.dd9dfcd0.js";import"./EntityToggleBadge.44abc0d0.js";import"./ConfirmModalDialog.f108eb33.js";import"./EntityDeleteModal.7f356b9e.js";const J={name:"PluginList",components:{EntityList:H,PageHeader:C,SupportText:K,ExternalLink:S,PluginIcon:j},mixins:[B,N,q],props:{hidePageHeader:{type:Boolean,default:!1},tableActions:{type:Object,default:()=>({showViewAction:!0,showUpdateAction:!0,showDeleteAction:!0})},optionFields:{type:Object,default:()=>{}},appliedToLinks:{type:Function,default:null},disableAppliedToLinks:{type:Boolean,default:!1},disableUpdateEntities:{type:Array,default:()=>[]},parentRoute:{type:String,default:""}},data(){return{unsortableFields:["applied_to","tags"]}},computed:{entityListOptions(){return{entity:this.entity||"plugins",entityName:"Plugin",emptyTitle:"Install a new plugin",ctaMessage:"Install Plugin",helpMessage:"Install plugins to extend Kong functionality.",supportDocs:"https://docs.konghq.com/hub",createRoute:this.parentRoute?`/${this.parentRoute}/plugins/select`:`/${this.workspace}/plugins/select`,parentRoute:this.parentRoute,fields:{name:{searchable:!0},enabled:{searchable:!0},applied_to:{label:"Applied To"},tags:{}},...this.$route.name!=="plugins"?{viewRouteQuery:this.createRedirectRouteQuery()}:null,...this.createRouteQuery?{createRouteQuery:{...this.createRouteQuery,...this.createRedirectRouteQuery(),consumerId:this.consumerId,serviceId:this.serviceId,routeId:this.routeId}}:null,...this.$route.name!=="plugins"?{viewText:"View configuration",editText:"Edit configuration",withRedirectQuery:!0}:null}},schema(){return{name:{type:"text"},enabled:{type:"select",values:["true","false"]},id:{type:"text"}}},cardClass(){return{"plugins-listing-card-no-border":this.$route.name!=="plugins"}}},methods:{...D(O,["getInfo"]),viewActionHandler(e){if(this.$route.name==="plugins")return this.$router.push({name:"view-plugin",params:{plugin:e.name,pluginId:e.id,workspace:this.$route.params.workspace,id:e.id}});const s=this.$route.params.workspace,i=e.name,a=e.id;let l=`/${s}/${this.entity}/${i}/${a}`;this.$route.name==="consumer-plugins"&&(l=`/${s}/consumers/${this.entity}/${i}/${a}`),this.$router.push({path:l,query:{...this.createRedirectRouteQuery(),consumerId:this.consumerId,serviceId:this.serviceId,routeId:this.routeId}})},updateActionHandler(e){return this.$router.push({name:"update-plugin",params:{plugin:e.name,pluginId:e.id,workspace:this.$route.params.workspace,id:e.id},...this.$route.name!=="plugins"?{query:{...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery(),consumerId:this.consumerId,serviceId:this.serviceId,routeId:this.routeId}}:null})},appliedToLinksFunc(e){if(!this.appliedToLinks===null)return this.appliedToLinks(e);const s={consumer:e.consumer,service:e.service,route:e.route},i={konnectService:e.servicePackage,konnectServiceVersion:e.serviceVersion};return Object.values(Object.keys(s).reduce((a,l)=>{const t=JSON.parse(JSON.stringify(s[l]));if(t){t.service=i.konnectService&&i.konnectService.id,t.version=i.konnectServiceVersion&&i.konnectServiceVersion.id;const y=l==="service"&&t.version?"show-service-version":`show-${l}`;a[l]={id:t.id,link:{name:y,params:t},label:V(l)}}return a},{}))},handleAfterDelete(){this.getInfo()},createEntity(){const{entityListOptions:e,$route:s,redirectPath:i}=this,a={$route:s,path:e.createRoute,query:{...e.createRouteQuery,consumerId:this.consumerId,serviceId:this.serviceId,routeId:this.routeId},redirect:i};s.name.startsWith("service")?a.field={service_id:this.serviceId}:s.name.startsWith("route")?a.field={route_id:this.routeId}:s.name.startsWith("consumer")&&(a.field={consumer_id:this.consumerId}),this.$router.push(M(a))},viewDetails(e){this.$router.push({name:"view-plugin",params:{plugin:e.name,id:e.id},query:{...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery(),consumerId:this.consumerId,serviceId:this.serviceId,routeId:this.routeId}})}}},U={class:"plugins-listing"},W=h(" Plugins allow you to extend Kong's capabilities with features like rate limiting, authentication, and logging. "),z=h(" Learn more "),G=["data-testid"],X=["data-testid"],Y=h(" View details ");function Z(e,s,i,a,l,t){const y=u("EntityFilter"),b=u("EntityButton"),I=u("ExternalLink"),w=u("SupportText"),L=u("PageHeader"),R=u("PluginIcon"),$=u("KBadge"),A=u("router-link"),E=u("KDropdownItem"),P=u("EntityList"),T=u("KCard");return c(),p("section",U,[i.hidePageHeader?g("",!0):(c(),m(L,{key:0},Q({default:o(()=>[e.$route.name==="plugins"?(c(),m(y,{key:0,entity:t.entityListOptions.entity,fields:t.entityListOptions.fields,schema:t.schema},null,8,["entity","fields","schema"])):g("",!0),d(b,{workspace:e.workspace,entity:`${t.entityListOptions.entity}`,"restricted-actions":["create"],"path-name":e.$route.name==="plugins"?"select-plugin":void 0,"button-props":{appearance:"primary"},text:"Install Plugin",onClick:s[0]||(s[0]=()=>e.$route.name!=="plugins"&&t.createEntity())},null,8,["workspace","entity","path-name"])]),_:2},[t.entityListOptions.supportDocs?{name:"below-title",fn:o(()=>[d(w,null,{default:o(()=>[F("p",null,[W,d(I,{href:t.entityListOptions.supportDocs},{default:o(()=>[z]),_:1},8,["href"])])]),_:1})])}:void 0]),1024)),d(T,{"border-variant":e.$route.name!=="plugins"?"noBorder":void 0,class:_(t.cardClass)},{body:o(()=>[d(P,{ref:"entitylist","unsortable-fields":l.unsortableFields,options:t.entityListOptions,"enable-entity-actions":!0,"show-view-action":!0,"view-action-fields":["name"],"view-action-handler":t.viewActionHandler,"update-action-handler":t.updateActionHandler,"disable-row-click":!0,"overflow-actions":!0,"disable-update-entities":i.disableUpdateEntities,onAfterDelete:t.handleAfterDelete},{name:o(r=>[d(R,{name:r.item.name,class:"plugin-icon"},null,8,["name"]),h(" "+f(r.item.name),1)]),applied_to:o(({item:r})=>[t.appliedToLinksFunc(r).length&&!i.disableAppliedToLinks?(c(!0),p(k,{key:0},v(t.appliedToLinksFunc(r),n=>(c(),m(A,{key:n.label,to:n.link,title:`${n.label} - ${n.id}`,"data-testid":`${n.label}-${n.id}-${r.id}`,class:"mr-2 flex items-center"},{default:o(()=>[d($,null,{default:o(()=>[h(f(n.label),1)]),_:2},1024)]),_:2},1032,["to","title","data-testid"]))),128)):t.appliedToLinksFunc(r).length&&i.disableAppliedToLinks?(c(!0),p(k,{key:1},v(t.appliedToLinksFunc(r),n=>(c(),p("span",{key:n.id,"data-testid":`${n.label}-${n.id}-${r.id}`},f(n.label),9,G))),128)):(c(),p("span",{key:2,"data-testid":`global-${r.id}`,class:_({badge:!i.disableAppliedToLinks})},"Global",10,X))]),extraViewActions:o(({item:r,rbac:{isAllowedToRead:n}})=>[e.$route.name!=="plugins"&&n?(c(),m(E,{key:0,"data-testaction":"menu-view-details",onClick:ee=>t.viewDetails(r)},{default:o(()=>[Y]),_:2},1032,["onClick"])):g("",!0)]),_:1},8,["unsortable-fields","options","view-action-handler","update-action-handler","disable-update-entities","onAfterDelete"])]),_:1},8,["border-variant","class"])])}const _e=x(J,[["render",Z]]);export{_e as default};
