/*
  This software is copyright Kong Inc. and its licensors.
  Use of the software is subject to the agreement between your organization
  and Kong Inc. If there is no such agreement, use is governed by and
  subject to the terms of the Kong Master Software License Agreement found
  at https://konghq.com/enterprisesoftwarelicense/.
*/


import{_ as k,K as x,s as d,L as D,V as S,c as C,b as i,J as O,w as o,q as Q,r as s,o as c,a as $,f as l,h as m,d as p}from"./index.9c766b32.js";import{E as T}from"./EntityMixin.41a00d96.js";import{P as I}from"./PageHeader.f57bc0c5.js";import{E as P}from"./EntityList.3eb9ead7.js";import{E as B}from"./EntityToggleBadge.44abc0d0.js";import{S as M}from"./SupportText.46d57bf3.js";import{g as N}from"./Route.57c6a685.js";import{M as V}from"./methodColors.038bf0d1.js";import{L as q}from"./ListPageMixin.043645e4.js";import{R as F}from"./RedirectMixin.43c88d07.js";import{b as H}from"./buildRoute.43b36aba.js";import"./EntityButton.b0e2795e.js";import"./EntityFilter.a45e67f0.js";import"./preferences.669a52f4.js";import"./EntityListEmptyState.595e7f8f.js";import"./icon-empty-table.dd9dfcd0.js";import"./EntityDeleteModal.7f356b9e.js";import"./ConfirmModalDialog.f108eb33.js";import"./ArrayCardContainerFields.b5ada08d.js";import"./typedefs.c23224fe.js";import"./index.b6366b96.js";import"./transform.2ef334b4.js";import"./marked.esm.54f47f7d.js";const A={name:"RouteList",components:{EntityList:P,EntityTags:B,PageHeader:I,SupportText:M,ExternalLink:x},mixins:[T,q,F],data(){return{unsortableFields:["protocols","methods","hosts","paths","tags"]}},computed:{...d(D,["entityDoc"]),...d(S,{config:"infoConfig"}),schema(){return this.buildSchema(N(this.config.router_flavor))},entityListOptions(){return{entity:this.entity||"routes",entityName:"Route",helpMessage:"Add routes to proxy requests to an associated Service.",showRouteName:"show-route",createRoute:`/${this.$route.params.workspace}/routes/create`,supportDocs:this.entityDoc("route"),fields:{name:{searchable:!0},protocols:{searchable:!0},methods:{searchable:!0},hosts:{searchable:!0},paths:{searchable:!0},tags:{}},...this.$route.name!=="routes"?{viewRouteQuery:{...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery()}}:null,...this.createRouteQuery?{createRouteQuery:{...this.createRouteQuery,...this.createRedirectRouteQuery()}}:null,...this.$route.name!=="routes"?{viewText:"View configuration",editText:"Edit configuration",withRedirectQuery:!0}:null}},cardClass(){return{"routes-listing-card-no-border":this.$route.name!=="routes"}}},methods:{buildSchema(e){const t=Object.assign({},e);return t.protocols={type:"select",values:["http","https","tcp","tls","udp","tls_passthrough","grpc","grpcs"]},t.methods={type:"text"},t.hosts={type:"text"},t.paths={type:"text"},t.id={type:"text"},t.name={type:"text"},t},colorizeMethods(e){const{foreground:t,background:a}=V[e]||{foreground:"#4B8500",background:"#EDFFD6"};return{label:e,foreground:t,background:a}},createEntity(){const{entityListOptions:e,$route:t,redirectPath:a}=this,n={$route:t,path:e.createRoute,query:e.createRouteQuery,redirect:a};this.$route.name.startsWith("service")&&(n.field={service_id:this.serviceId}),this.$router.push(H(n))},updateActionHandler(e){return this.$router.push({name:"update-route",params:{workspace:this.$route.params.workspace,id:e.id},...this.$route.name!=="routes"?{query:{...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery(),serviceId:this.serviceId}}:null})},viewDetails({id:e}){this.$router.push({name:this.entityListOptions.showRouteName,params:{id:e},...this.$route.name!=="routes"?{query:{...this.createRedirectRouteQuery(),...this.createPostDeleteRouteQuery(),serviceId:this.serviceId}}:null})}}},K={class:"routes-listing"},z=p(" A Route defines rules to match client requests, and is associated with a Service. "),j=p(" Learn more "),J=p(" View details ");function W(e,t,a,n,h,r){const y=s("EntityFilter"),f=s("EntityButton"),_=s("ExternalLink"),g=s("SupportText"),w=s("PageHeader"),R=s("EntityTags"),b=s("KDropdownItem"),v=s("EntityList"),L=s("KCard");return c(),C("section",K,[i(w,null,O({default:o(()=>[e.$route.name==="routes"?(c(),l(y,{key:0,entity:r.entityListOptions.entity,fields:r.entityListOptions.fields,schema:r.schema},null,8,["entity","fields","schema"])):m("",!0),i(f,{workspace:e.workspace,entity:`${r.entityListOptions.entity}`,"restricted-actions":["create"],"path-name":e.$route.name==="routes"?"create-route":void 0,"button-props":{appearance:"primary"},text:"New Route",onClick:t[0]||(t[0]=()=>e.$route.name!=="routes"&&r.createEntity())},null,8,["workspace","entity","path-name"])]),_:2},[r.entityListOptions.supportDocs?{name:"below-title",fn:o(()=>[i(g,null,{default:o(()=>[$("p",null,[z,i(_,{href:r.entityListOptions.supportDocs},{default:o(()=>[j]),_:1},8,["href"])])]),_:1})])}:void 0]),1024),i(L,{"border-variant":e.$route.name!=="routes"?"noBorder":void 0,class:Q(r.cardClass)},{body:o(()=>[i(v,{ref:"entitylist",options:r.entityListOptions,"unsortable-fields":h.unsortableFields,"enable-entity-actions":!0,"show-view-action":!0,"view-action-fields":["name"],"update-action-handler":r.updateActionHandler,"disable-row-click":!0,"overflow-actions":!0},{methods:o(({item:u})=>[i(R,{tags:(u.methods||[]).map(r.colorizeMethods)},null,8,["tags"])]),extraViewActions:o(({item:u,rbac:{isAllowedToRead:E}})=>[e.$route.name!=="routes"&&E?(c(),l(b,{key:0,"data-testaction":"menu-view-details",onClick:G=>r.viewDetails(u)},{default:o(()=>[J]),_:2},1032,["onClick"])):m("",!0)]),_:1},8,["options","unsortable-fields","update-action-handler"])]),_:1},8,["border-variant","class"])])}const we=k(A,[["render",W],["__scopeId","data-v-3c86cf07"]]);export{we as default};
