/*
  This software is copyright Kong Inc. and its licensors.
  Use of the software is subject to the agreement between your organization
  and Kong Inc. If there is no such agreement, use is governed by and
  subject to the terms of the Kong Master Software License Agreement found
  at https://konghq.com/enterprisesoftwarelicense/.
*/


import{_ as g,K as y,s as E,L as v,c as h,b as a,w as d,r as i,o as u,a as n,q as C,h as x,d as c}from"./index.9c766b32.js";import{P as B}from"./PageHeader.f57bc0c5.js";import{E as U}from"./EntityForm.df067f53.js";import{F as A}from"./FormPage.44158cf3.js";import{R as F}from"./RolesModal.ab4f7a3a.js";import"./ConfirmModalDialog.f108eb33.js";import"./EntityDeleteModal.7f356b9e.js";import"./EntityMixin.41a00d96.js";import"./EntityButton.b0e2795e.js";import"./EntityFilter.a45e67f0.js";import"./RedirectMixin.43c88d07.js";import"./MultiChecklist.ac899fe2.js";const M={name:{type:"input",inputType:"text",label:"Name",required:!0},user_token:{type:"input",inputType:"text",label:"User Token",required:!0},comment:{type:"input",inputType:"text",label:"Comment",styleClasses:"optional"},enabled:{type:"checkbox",default:!0,label:"Enabled",styleClasses:"optional",help:"An RBAC User that is enabled can make API requests"}};const V={name:"RbacForm",components:{PageHeader:B,EntityForm:U,RolesModal:F,ExternalLink:y},mixins:[A],data(){return{schema:M,isModalVisible:!1,userId:null,userRoles:[],changedRoles:{added:[],deleted:[]},enableSubmit:!1}},computed:{...E(v,{docsBase:"docsEnterprise"}),workspace(){return this.$route.params.workspace},docsLink(){return`${this.docsBase.url}admin-api/rbac/reference/`},id(){return this.$route.params.id},resourceEndpoint(){return"rbac/users"},tableData(){return{headers:[{label:"Role",key:"name"},{label:"Comment",key:"comment"}],data:this.userRoles.length&&this.userRoles[0].roles||[]}},breadcrumbItems(){const s=this.$route.params.workspace,e=[{key:"teams-overview",to:{path:"/teams",query:{workspace:s},hash:"#rbac-users"},title:"Team RBAC Users",text:"Teams"}];return this.isEditing&&e.push({key:"view-rbac-user",to:{name:"show-rbac-user",params:{workspace:s}},title:`View ${this.id}`,text:this.id}),e}},beforeMount(){this.isEditing&&this.fetchUserRoles()},methods:{fetchUserRoles(){this.$api.query(`${this.workspace}/rbac/users/${this.id}/roles`).then(s=>{this.userRoles=[{workspace:this.workspace,roles:s.data.roles}]})},saveUserRoles(s){const e=[],t=s[this.workspace];if(this.isModalVisible=!1,Object.assign(this.changedRoles,t.added&&{added:t.added},t.deleted&&{deleted:t.deleted}),e.push({workspace:this.workspace,roles:t.added}),this.userRoles[0]&&this.userRoles[0].roles){if(t.added)for(let l=0;l<e[0].roles.length;l++)this.userRoles[0].roles.push(e[0].roles[l]);if(t.deleted){const l=this.changedRoles.deleted.map(r=>r.name);this.userRoles[0].roles=this.userRoles[0].roles.filter(r=>!l.includes(r.name))}}else this.userRoles=e;this.enableSubmit=!0},submitRoles(s){const e=[];return this.userRoles.length===0?this.handleSuccess():(this.changedRoles.added.length&&e.push(this.$api.createRecordWithWorkspace(this.workspace,`rbac/users/${s}/roles`,{roles:this.changedRoles.added.map(t=>t.name).join(",")})),this.changedRoles.deleted.length&&e.push(this.$api.deleteRecordWithWorkspaceAndBody(this.workspace,`rbac/users/${s}/roles`,{roles:this.changedRoles.deleted.map(t=>t.name).join(",")})),Promise.all(e))},createRecord(s){return this.$api.createRecordWithWorkspace(this.workspace,this.resourceEndpoint,s).then(e=>this.submitRoles(e.data.id)).then(this.handleSuccess)},updateRecord(s){return this.$api.updateRecordWithWorkspace(this.workspace,this.resourceEndpoint,this.id,s).then(e=>this.submitRoles(e.data.id)).then(this.handleSuccess)},deleteRecord(){return this.$api.deleteRecordWithWorkspace(this.workspace,this.resourceEndpoint,this.id)},handleDelete(){return this.onDeleteWhenEditing()},handleSuccess(){this.$router.push({path:"/teams",hash:"#rbac-users",query:{workspace:this.workspace}})},rowClickHandler(s,e){this.$router.push({name:"teams-update-role",params:{workspace:this.workspace,id:e.id}})}}},W={class:"rbac-user-form form-container"},S=c(" View docs "),T={class:"d-flex justify-content-between align-items-center"},D=n("div",null,[n("label",{class:"mb-0"},"Roles")],-1),L=c(" Add/Edit Roles "),P=n("p",{class:"hint mt-4 mb-0"}," An RBAC User can belong to only one workspace. ",-1),q={key:0,class:"roles-table pb-4"},K=n("strong",null,"Note:",-1),N=c(" A User can only be added to one workspace at a time. ");function $(s,e,t,l,r,o){const m=i("KBreadcrumbs"),p=i("ExternalLink"),b=i("PageHeader"),k=i("KButton"),R=i("KTable"),f=i("EntityForm"),_=i("RolesModal");return u(),h("section",W,[a(m,{items:o.breadcrumbItems},null,8,["items"]),a(b,null,{default:d(()=>[a(p,{href:o.docsLink},{default:d(()=>[S]),_:1},8,["href"])]),_:1}),a(f,{"is-editing":s.isEditing,"show-confirmation-dialog":!1,schema:r.schema,"button-text":s.buttonText,"on-load":s.onFormLoad,"on-submit":s.onFormSubmit,"enable-submit":r.enableSubmit,"on-delete":o.handleDelete,"resource-endpoint":o.resourceEndpoint,"redirect-route-after-delete":{name:"teams-overview",hash:"#rbac-users"},"entity-name":"User",entity:"rbac/users"},{afterFormContainer:d(()=>[n("div",{class:C([{"border-bottom pb-4":!o.tableData.data.length},"mb-4 pt-4 border-top roles-section"])},[n("div",T,[D,n("div",null,[a(k,{class:"roles-btn",appearance:"outline",onClick:e[0]||(e[0]=w=>r.isModalVisible=!0)},{default:d(()=>[L]),_:1})])]),P],2),o.tableData.data.length?(u(),h("div",q,[a(R,{headers:o.tableData.headers,fetcher:()=>({data:o.tableData.data||[]}),"disable-pagination":!0,"empty-state-title":"No roles assigned","onRow:click":o.rowClickHandler},null,8,["headers","fetcher","onRow:click"])])):x("",!0)]),_:1},8,["is-editing","schema","button-text","on-load","on-submit","enable-submit","on-delete","resource-endpoint"]),a(_,{"is-visible":r.isModalVisible,workspace:o.workspace,"selected-roles":r.userRoles,"modal-proceed-text":`${s.isEditing?"Edit":"Add"} Roles`,onConfirm:o.saveUserRoles,onCancel:e[1]||(e[1]=w=>r.isModalVisible=!1)},{modalAlertMessage:d(()=>[K,N]),_:1},8,["is-visible","workspace","selected-roles","modal-proceed-text","onConfirm"])])}const se=g(V,[["render",$]]);export{se as default};
